; BCC 34
; ASCII Maze von ZaP
AppTitle "ASCII maze von ZaP"

;Zufall initialisieren
SeedRnd MilliSecs()

;grafik einstellen
Graphics3D 800, 600, 32, 2
SetBuffer BackBuffer()

;maze struktur
Dim maze(31, 31)

;ascii-fi renderer
Include "asciifi.bb"

;kamera, licht, ...
Local gamecam = CreateCamera()
Local s = CreateLight(2, gamecam)
PositionEntity gamecam, 5, 2, 5
AmbientLight 0, 0, 0
LightRange s, 2
EntityRadius gamecam, 1.5
EntityType gamecam, 1

;zielpunkt
Local t = CreateSphere()
EntityType t, 3

DeployTarget(t)

;maze generieren
MakeMaze()

;FPS limitieren
Local limiter = CreateTimer(30)

Collisions 1, 2, 3, 3

;hauptschleife
Repeat
	
	Cls
	
	WaitTimer(limiter)
	
	;spieler bewegung
	TurnEntity gamecam, 0.0, (KeyDown(203) - KeyDown(205)) * 5.0, 0.0
	MoveEntity gamecam, 0.0, 0.0, Float(KeyDown(200) - KeyDown(208)) / 5.0
	
	;kollisionen
	UpdateWorld
	
	;ziel erreicht?
	If EntityDistance(t, gamecam) <= 4.0
		RuntimeError "Du hast das Spiel gewonnen!"
	EndIf
	
	;rendern
	ASCIIfi(gamecam, 64, 48)
	
	Flip 0
	
Until KeyHit(1)


Function MakeMaze(w = 15, h = 15)
	
	Local x, y
	Local mazeimg = CreateImage(w, h)
	Local dir, size
	
	;bild erzeugen
	;es besteht aus schwarzen und weien pixeln, die fr einen cube stehen
	SetBuffer ImageBuffer(mazeimg)
	
	;aussenrand
	Rect 0, 0, w, h, 0
	
	;wer an diesem generierungsalgo interessiert ist, mge folgende adresse besuchen:
	;http://www2.informatik.uni-erlangen.de/EN/teaching/WS2005/GameAlgHS/download/Rathmann-Prozedurale_Labyrinth-Generierung.pdf
	For y = 0 To h
		For x = 0 To w
			If x Mod 2 And y Mod 2 And maze(x, y) = 0 And x <> 1 And y <> 1
				dir = Rand(0, 3)
				size = Rand(3)
				
				Select dir
					Case 0
						If y - size < 0 Then size = y
						
						For i = 0 To size
							maze(x, y - i) = 1
							Plot x, y - i
						Next
						
					Case 1
						If x + size > w Then size = w - x
						
						For i = 0 To size
							maze(x + i, y) = 1
							Plot x + i, y
						Next
						
					Case 2
						If y + size > h Then size = h - y
						
						For i = 0 To size
							maze(x, y + i) = 1
							Plot x, y + i
						Next
						
					Case 3
						If x - size < 0 Then size = x
						
						For i = 0 To size
							maze(x - i, y) = 1
							Plot x - i, y
						Next
						
				End Select
			EndIf
		Next
	Next
	
	;bild auslesen, cubes erstellen
	Local rgb
	Local c
	
	For y = 0 To h
		For x = 0 To w
			
			rgb = ReadPixel(x, y)
			
			If Hex(rgb) <> "FF000000"
				c = CreateCube()
				ScaleEntity c, 2.5, 2.5, 2.5
				PositionEntity c, x * 5, 2.5, y * 5
				EntityBox c, -2.5, -2.5, -2.5, 5.0, 5.0, 5.0
				EntityType c, 2
			EndIf
		Next
	Next
	
	SetBuffer BackBuffer()
	
	FreeImage mazeimg
	
End Function


Function DeployTarget(t, w = 15, h = 15)
	
	Local x, y
	
	Repeat
		x = Rand(w)
		y = Rand(h)
	Until maze(x, y) = 0
	
	PositionEntity t, x * 5.0, 3.0, y * 5.0
	
End Function


End
;~IDEal Editor Parameters:
;~C#Blitz3D